/****************************************************************************
   modified on 28th February 2003 by nakazato@phy.cam.ac.uk

** Form implementation generated from reading ui file 'slcalcbase.ui'
**
** Created: Thu Feb 20 09:28:52 2003
**      by:  The User Interface Compiler (uic)
**
****************************************************************************/
#include "slcalcbase.h"

#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qapplication.h>

#define SIZEP 5
#define SIZEF false
#define _size(w) {                                                   \
        w->setSizePolicy(QSizePolicy((QSizePolicy::SizeType)SIZEP,   \
                              (QSizePolicy::SizeType)SIZEP, SIZEF)); \
        w->setPalette( pal );                                        \
    }
#define _font(w, w_font, size) {                    \
        QFont w_font(  w->font() );                 \
        w_font.setPointSize( size );                \
        w_font.setBold( TRUE );                     \
        w->setFont( w_font );                       \
    }
#define _pushbutton(w, w_font, s) {                 \
        _size(w);                                   \
        QFont w_font(  w->font() );                 \
        w_font.setPointSize( fsize );               \
        w_font.setBold( TRUE );                     \
        w->setFont( w_font );                       \
        w->setFocusPolicy( QPushButton::NoFocus );  \
        w->setText( tr( s ) );                      \
    }
#define _pushbuttons(w, w_font, s) {                \
        _size(w);                                   \
        QFont w_font(  w->font() );                 \
        w_font.setPointSize( sfsize );              \
        w_font.setBold( TRUE );                     \
        w->setFont( w_font );                       \
        w->setFocusPolicy( QPushButton::NoFocus );  \
        w->setText( tr( s ) );                      \
    }

bool QVGA = false;

/* 
 *  Constructs a slcalcBase which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
slcalcBase::slcalcBase( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name ) setName( "slcalcBase" );
    setCaption( tr( "slcalc" ) );

#include "pal1"

    QWidget *d = QApplication::desktop();
    QVGA = ( d->width() < 400 )&&( d->height() < 400);
    int fsize, sfsize;
    if (QVGA) {
        fsize  = 24;
        sfsize = 18;
    } else {
        fsize  = 36;
        sfsize = 26;
    }

    topLayout = new QVBoxLayout(this, 0);
    QGridLayout *grid = new QGridLayout(topLayout, 24, 24, 0);
    int i;
    for (i=0; i<23; i++) {
        grid->addRowSpacing(i, 10);
        grid->setRowStretch(i, 1);
    }
    grid->addRowSpacing(24, 3);
    grid->setRowStretch(24, 0);
    for (i=0; i<24; i++) {
        grid->addColSpacing(i, 10);
        grid->setColStretch(i, 1);
    }

    MultiLineEdit1 = new slcalcMultiLineEdit( this, "MultiLineEdit1" );
    grid->addMultiCellWidget( MultiLineEdit1 , 0, 5, 0, 19);
    _size(MultiLineEdit1);
    _font(MultiLineEdit1, MultiLineEdit1_font, sfsize);
    MultiLineEdit1->setCursor( QCursor( 0 ) );
    MultiLineEdit1->setMouseTracking( TRUE );
    MultiLineEdit1->setFocusPolicy( QMultiLineEdit::StrongFocus );
    MultiLineEdit1->setWordWrap( QMultiLineEdit::WidgetWidth );
    MultiLineEdit1->setWrapPolicy( QMultiLineEdit::Anywhere );

    LineEdit2 = new QLineEdit( this, "LineEdit2" );
    grid->addMultiCellWidget( LineEdit2 , 6, 7, 0, 14);
    _size(LineEdit2);
    _font(LineEdit2, LineEdit2_font, sfsize);
    LineEdit2->setEnabled( FALSE );
    LineEdit2->setFocusPolicy( QLineEdit::NoFocus );
    LineEdit2->setAcceptDrops( FALSE );

    ListBox1 = new QListBox( this, "ListBox1" );
    grid->addMultiCellWidget( ListBox1 , 6, 14, 15, 23);
    _size(ListBox1);
    _font(ListBox1, ListBox1_font, sfsize);
    ListBox1->setFocusPolicy( QListBox::NoFocus );
    ListBox1->setFrameShape( QListBox::StyledPanel );
    ListBox1->setFrameShadow( QListBox::Sunken );
    ListBox1->setVScrollBarMode( QListBox::AlwaysOn );
    ListBox1->setHScrollBarMode( QListBox::AlwaysOff );

    ListBox2 = new QListBox( this, "ListBox2" );
    grid->addMultiCellWidget( ListBox2 , 15, 22, 15, 23);
    _size(ListBox2);
    _font(ListBox2, ListBox2_font, sfsize);
    ListBox2->setFocusPolicy( QListBox::NoFocus );
    ListBox2->setFrameShape( QListBox::StyledPanel );
    ListBox2->setFrameShadow( QListBox::Sunken );
    ListBox2->setVScrollBarMode( QListBox::AlwaysOn );
    ListBox2->setHScrollBarMode( QListBox::AlwaysOff );

    PushButtonBs = new QPushButton( this, "PushButtonBs" );
    grid->addMultiCellWidget( PushButtonBs , 0, 1, 20, 23);
    _pushbuttons(PushButtonBs, PushButtonBs_font, "BS")

    PushButtonCls = new QPushButton( this, "PushButtonCls" );
    grid->addMultiCellWidget( PushButtonCls , 2, 3, 20, 23);
    _pushbuttons(PushButtonCls, PushButtonCls_font, "C")

    PushButtonRecall = new QPushButton( this, "PushButtonRecall" );
    grid->addMultiCellWidget( PushButtonRecall , 4, 5, 20, 21);
    _pushbuttons(PushButtonRecall, PushButtonRecall_font, "<")

    PushButtonBackrecall = new QPushButton( this, "PushButtonBackrecall" );
    grid->addMultiCellWidget( PushButtonBackrecall , 4, 5, 22, 23);
    _pushbuttons(PushButtonBackrecall, PushButtonBackrecall_font, ">")

    PushButton0 = new QPushButton( this, "PushButton0" );
    grid->addMultiCellWidget(PushButton0, 20, 22, 0, 2);
    _pushbutton(PushButton0, PushButton0_font, "0")

    PushButtonDot = new QPushButton( this, "PushButtonDot" );
    grid->addMultiCellWidget(PushButtonDot, 20, 22, 3, 5);
    _pushbutton(PushButtonDot, PushButtonDot_font, ".")

    PushButtonEnt = new QPushButton( this, "PushButtonEnt" );
    grid->addMultiCellWidget(PushButtonEnt, 20, 22, 6, 8);
    _pushbuttons(PushButtonEnt, PushButtonEnt_font, "Ent")

    PushButton1 = new QPushButton( this, "PushButton1" );
    grid->addMultiCellWidget(PushButton1, 17, 19, 0, 2);
    _pushbutton(PushButton1, PushButton1_font, "1")

    PushButton2 = new QPushButton( this, "PushButton2" );
    grid->addMultiCellWidget(PushButton2, 17, 19, 3, 5);
    _pushbutton(PushButton2, PushButton2_font, "2")

    PushButton3 = new QPushButton( this, "PushButton3" );
    grid->addMultiCellWidget(PushButton3, 17, 19, 6, 8);
    _pushbutton(PushButton3, PushButton3_font, "3")

    PushButton4 = new QPushButton( this, "PushButton4" );
    grid->addMultiCellWidget(PushButton4, 14, 16, 0, 2);
    _pushbutton(PushButton4, PushButton4_font, "4")

    PushButton5 = new QPushButton( this, "PushButton5" );
    grid->addMultiCellWidget(PushButton5, 14, 16, 3, 5);
    _pushbutton(PushButton5, PushButton5_font, "5")

    PushButton6 = new QPushButton( this, "PushButton6" );
    grid->addMultiCellWidget(PushButton6, 14, 16, 6, 8);
    _pushbutton(PushButton6, PushButton6_font, "6")

    PushButton7 = new QPushButton( this, "PushButton7" );
    grid->addMultiCellWidget(PushButton7, 11, 13, 0, 2);
    _pushbutton(PushButton7, PushButton7_font, "7")

    PushButton8 = new QPushButton( this, "PushButton8" );
    grid->addMultiCellWidget(PushButton8, 11, 13, 3, 5);
    _pushbutton(PushButton8, PushButton8_font, "8")

    PushButton9 = new QPushButton( this, "PushButton9" );
    grid->addMultiCellWidget(PushButton9, 11, 13, 6, 8);
    _pushbutton(PushButton9, PushButton9_font, "9")

    PushButtonPlus = new QPushButton( this, "PushButtonPlus" );
    grid->addMultiCellWidget(PushButtonPlus, 11, 12, 9, 11);
    _pushbuttons(PushButtonPlus, PushButtonPlus_font, "+")

    PushButtonMinus = new QPushButton( this, "PushButtonMinus" );
    grid->addMultiCellWidget(PushButtonMinus, 11, 12, 12, 14);
    _pushbuttons(PushButtonMinus, PushButtonMinus_font, "-")

    PushButtonDiv = new QPushButton( this, "PushButtonDiv" );
    grid->addMultiCellWidget(PushButtonDiv, 13, 14, 9, 11);
    _pushbuttons(PushButtonDiv, PushButtonDiv_font, "/")

    PushButtonMul = new QPushButton( this, "PushButtonMul" );
    grid->addMultiCellWidget(PushButtonMul, 13, 14, 12, 14);
    _pushbuttons(PushButtonMul, PushButtonMul_font, "*")

    PushButtonPercent = new QPushButton( this, "PushButtonPercent" );
    grid->addMultiCellWidget(PushButtonPercent, 15, 16, 9, 11);
    _pushbuttons(PushButtonPercent, PushButtonPercent_font, "%")

    PushButtonPow = new QPushButton( this, "PushButtonPow" );
    grid->addMultiCellWidget(PushButtonPow, 15, 16, 12, 14);
     _pushbuttons(PushButtonPow, PushButtonPow_font, "^")

    PushButtonLp = new QPushButton( this, "PushButtonLp" );
    grid->addMultiCellWidget(PushButtonLp, 17, 18, 9, 11);
    _pushbuttons(PushButtonLp, PushButtonLp_font, "(")

    PushButtonRp = new QPushButton( this, "PushButtonRp" );
    grid->addMultiCellWidget(PushButtonRp, 17, 18, 12, 14);
    _pushbuttons(PushButtonRp, PushButtonRp_font, ")")

    PushButtonComma = new QPushButton( this, "PushButtonComma" );
    grid->addMultiCellWidget(PushButtonComma, 19, 20, 9, 11);
    _pushbuttons(PushButtonComma, PushButtonComma_font, ",")

    PushButtonSpace = new QPushButton( this, "PushButtonSpace" );
    grid->addMultiCellWidget(PushButtonSpace, 19, 20, 12, 14);
    _pushbuttons(PushButtonSpace, PushButtonSpace_font, " ")

    PushButtonEe = new QPushButton( this, "PushButtonEe" );
    grid->addMultiCellWidget(PushButtonEe, 21, 22, 9, 11);
    _pushbuttons(PushButtonEe, PushButtonEe_font, "e")

    PushButtonEq = new QPushButton( this, "PushButtonEq" );
    grid->addMultiCellWidget(PushButtonEq, 21, 22, 12, 14);
    _pushbuttons(PushButtonEq, PushButtonEq_font, "=")

    RadioButtonN = new QRadioButton( this, "RadioButtonN" );
    if (QVGA)
        grid->addMultiCellWidget( RadioButtonN , 8, 10, 0, 2);
    else
        grid->addMultiCellWidget( RadioButtonN , 8, 10, 0, 1);
    _size(RadioButtonN);
    RadioButtonN->setFocusPolicy( QRadioButton::NoFocus );
    RadioButtonN->setText( tr( "n" ) );

    RadioButtonF = new QRadioButton( this, "RadioButtonF" );
    if (QVGA)
        grid->addMultiCellWidget( RadioButtonF , 8, 10, 3, 5);
    else
        grid->addMultiCellWidget( RadioButtonF , 8, 10, 2, 3);
    _size(RadioButtonF);
    RadioButtonF->setFocusPolicy( QRadioButton::NoFocus );
    RadioButtonF->setText( tr( "f" ) );

    RadioButtonE = new QRadioButton( this, "RadioButtonE" );
    if (QVGA)
        grid->addMultiCellWidget( RadioButtonE , 8, 10, 6, 8);
    else
        grid->addMultiCellWidget( RadioButtonE , 8, 10, 4, 5);
    _size(RadioButtonE);
    RadioButtonE->setFocusPolicy( QRadioButton::NoFocus );
    RadioButtonE->setText( tr( "e" ) );

    RadioButtonRad = new QRadioButton( this, "RadioButtonRad" );
    if (QVGA) {
        grid->addMultiCellWidget( RadioButtonRad , 8, 10, 9, 11);
        RadioButtonRad->setText( tr( "r" ) );
    } else {
        grid->addMultiCellWidget( RadioButtonRad , 8, 10, 8, 10);
        RadioButtonRad->setText( tr( "rad" ) );
    }
    _size(RadioButtonRad);
    RadioButtonRad->setFocusPolicy( QRadioButton::NoFocus );

    RadioButtonDeg = new QRadioButton( this, "RadioButtonDeg" );
    if (QVGA) {
        grid->addMultiCellWidget( RadioButtonDeg , 8, 10, 12, 14);
        RadioButtonDeg->setText( tr( "d" ) );
    } else {
        grid->addMultiCellWidget( RadioButtonDeg , 8, 10, 11, 13);
        RadioButtonDeg->setText( tr( "deg" ) );
    }
    _size(RadioButtonDeg);
    RadioButtonDeg->setFocusPolicy( QRadioButton::NoFocus );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
slcalcBase::~slcalcBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
 */
bool slcalcBase::event( QEvent* ev )
{
    bool ret = QWidget::event( ev );

//    if ( ev->type() == QEvent::ApplicationFontChange ) { }
    return ret;
}

