// file slcalcMultiLineEdit.cpp
//   copyright  nakazato@phy.cam.ac.uk
//   23rd Feb. 2003
//   26th July 2003

#include "slcalcMultiLineEdit.h"

slcalcMultiLineEdit::slcalcMultiLineEdit(QWidget* parent, const char* name)
    : QMultiLineEdit(parent, name)
{
}

slcalcMultiLineEdit::~slcalcMultiLineEdit()
{
}

void slcalcMultiLineEdit::delMarkedRegion()
{
    int line1, col1, line2, col2, len;

    if (getMarkedRegion(&line1, &col1, &line2, &col2)) {
        QString t = text();
        unsigned int i = 0;
        int lno = 0;
        if ( line1 > 0) {
            for ( ; (i < t.length()) && (lno!= line1); i++)
                if (t.at(i)=='\n') lno ++;
            i ++;
        }
        int i1 = i + col1;
        if (line2 == line1) len = col2 - col1;
        else {
            for ( ; (i < t.length()) && (lno != line2); i++)
                if (t.at(i)=='\n') lno ++;
            i ++;
            len = i + col2 - i1;
        }
        t.remove( i1 , len);
        setText(t);
        setCursorPosition(line1, col1);
    }
}
