// file slcalcMultiLineEdit.h
//   copyright  nakazato@phy.cam.ac.uk
//   23rd Feb. 2003

#include <qmultilineedit.h>

class slcalcMultiLineEdit : public QMultiLineEdit
{
    Q_OBJECT
	    
    public:
        slcalcMultiLineEdit(QWidget* parent = 0, const char* name = 0);
        ~slcalcMultiLineEdit();
        void delMarkedRegion();
        void cursorL(bool mark = false) { cursorLeft(mark);  }
        void cursorR(bool mark = false) { cursorRight(mark); }
        void cursorU(bool mark = false) { cursorUp(mark);    }
        void cursorD(bool mark = false) { cursorDown(mark);  }
        void bs() { backspace(); }
        void nl() { newLine();   }
        void dl() { del();       }

    protected:
        void keyPressEvent(QKeyEvent *key) { emit keyPress(key); }

    signals:
        void keyPress(QKeyEvent *key);
};
